<script>
import DataTable from '@/mixins/data-table'
import LocalStorage from '@/mixins/local-storage'
import getDataManifest from '@/assets/get-data-manifest'

export default {
  name: 'ServicePingPage',
  mixins: [DataTable, LocalStorage],

  async asyncData() {
    return { dataManifest: await getDataManifest() }
  },

  data() {
    return {
      namespace: 'service-ping',
      fetchedData: [],
      rows: [],
      paginationLimit: 10,
      columns: [
        {
          key: 'key_path',
          label: 'Key Path',
          sortable: true,
          thStyle: { width: '300px' },
        },
        { key: 'time_frame', label: 'Timeframe', sortable: true },
        { key: 'data_source', label: 'Source', sortable: true },
        { key: 'data_category', label: 'Category', sortable: true },
        { key: 'status', label: 'Status', sortable: true },
        { key: 'product_group', label: 'Group', sortable: true },
        { key: 'tiers', label: 'Tiers', sortable: true },
        { key: 'milestone', label: 'Milestone', sortable: true },
        {
          key: 'metric_trend_dashboard',
          label: 'Metric Trend Dashboard',
          sortable: false,
        },
        {
          key: 'product_categories',
          label: 'Product Categories',
          sortable: false,
        },
      ],
      dataUrl: '',
      sharePath: '',
    }
  },

  head() {
    return {
      title: 'Service Ping',
    }
  },
  created() {
    this.dataUrl = new URL(
      `data/service_ping.${this.dataManifest.service_ping}.json`,
      location.origin,
    ).toString()
    this.fetchData()
  },
}
</script>

<template>
  <div class="px-4 sm:px-6 lg:px-8">
    <div>
      <md-table-config
        :columns="columns"
        :rows="fetchedData"
        :namespace="namespace"
        :pagination-limit="paginationLimit"
        :share-path="sharePath"
        export-path="/data/service_ping.csv"
        :submit-search="submitSearch"
        :clear-search="clearSearch"
        context="metric"
        @search="handleSearch"
        @columns-change="handleColumnsChange"
        @pagination-limit-change="handlePaginationLimitChange"
      />
    </div>

    <md-table :columns="columns" :rows="rows" context="metric" />
  </div>
</template>
